#include <stdio.h>
#include <stdlib.h>

#define ARGINT(n) atoi(argv[n])

int randint(int from, int to)
{
	return from + rand() % (to-from+1);
}

int main(int argc, char *argv[])
{
	if(argc != 6) {
		fprintf(stderr, "usage: %s seed minn maxn minm maxm\n", argv[0]);
		return 1;
	}

	srand(ARGINT(1));
	int n = randint(ARGINT(2), ARGINT(3));
	int m = randint(ARGINT(4), ARGINT(5)) + n;
	printf("%d %d\n", n, m);

	int rays = 1;
	while ((rays+1)*(rays+1) < n-1)
		rays++;
	int rsize = (n-1) / rays;
	// printf("rays=%d rsize=%d => %d < %d\n", rays, rsize, rays*rsize+1, n);

	for (int i=0; i<rays; i++) {
		printf("%d %d\n", i*rsize + 1, n);
		for (int j=0; j<rsize-1; j++)
			printf("%d %d\n", i*rsize + j+1, i*rsize + j+2);
		m -= rsize;
	}

	for (int i=0; i<m; i++) {
		int x, y;
		do {
			int r1 = randint(0, rays-2);
			int r2 = randint(0, rays-2);
			x = randint(rsize/2, rsize-1) + r1*rsize + 1;
			y = randint(rsize/2, rsize-1) + r2*rsize + 1;
		} while (x == y);
		printf("%d %d\n", x, y);
	}

	return 0;
}
