#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static void
fail (char *fn)
{
  fprintf (stderr, "Chyba v %s\n", fn);
  abort ();
}

static const int maxn[] =
{
  10,
  10,
  20,
  20,
  40,
  40,
  40,
  40,
  40,
  40
};
static const long long maxm[] =
{
  1000000,
  1000000,
  1000000000000000000ll,
  1000000000000000000ll,
  1000000,
  1000000,
  1000000,
  1000000000000000000ll,
  1000000000000000000ll,
  1000000000000000000ll
};

#define MAXONE 10000000000000000ll

int main (int argc, char *argv[])
{
  char *fn = argv[1], *b;
  int testno;
  FILE *f;
  int i, n;
  long long m;

  b = strchr (fn, '.') + 1;
  testno = atoi (b) - 1;

  if (testno < 0 || testno > 9)
    fail (fn);

  f = fopen (fn, "r");
  if (fscanf (f, "%d%lld", &n, &m) != 2)
    fail (fn);

  if (n <= 0 || n > maxn[testno]
      || m <= 0 || m > maxm[testno])
    fail (fn);

  for (i = 0; i < n; i++)
    {
      if (fscanf (f, "%lld", &m) != 1)
	fail (fn);

      if (m <= 0 || m > MAXONE)
	fail (fn);
    }

  if (fscanf (f, "%lld", &m) == 1)
    fail (fn);

  return 0;
}
